#!/bin/bash  

SYS="/etc/sysconfig/envole"

. ParseDico
. /usr/share/eole/FonctionsEoleNg

# compatibilite
RNE_ETAB=$numero_etab
NOM_ETAB=`EscapeSQL "$libelle_etab"`
NOM_ETAB=`ToISO "$NOM_ETAB"`
NOM_DOMAINE=$domaine_messagerie_etab

echo "Creation des comptes servant de modeles"

id Meta_eleve &>/dev/null || /usr/share/eole/backend/creation-prof.py -u "Meta_eleve" \
	-m "meta_eleve" -p "Meta eleve" -f "meta_eleve" -x 1 -M local -p 1 -z 0 -c autre -q 0;
id Meta_prof &>/dev/null || /usr/share/eole/backend/creation-prof.py -u "Meta_prof" \
	-m "meta_prof" -p "Meta prof" -f "meta_prof" -x 1 -M local -p 1  -z 0 -c autre -q 0;
id Meta_perdir &>/dev/null || /usr/share/eole/backend/creation-prof.py -u "Meta_perdir" \
	-m "meta_perdir" -p "Meta perdir" -f "meta_perdir" -x 1 -M local -p 1  -z 0 -c autre -q 0;
id Visiteur &>/dev/null || /usr/share/eole/backend/creation-prof.py -u "Visiteur" \
	-m "Visiteur" -p "%CeL_accueil%" -f "visiteur" -x 1 -M local -p 1  -z 0 -c autre -q 0;

## creation des bases et des users ##
PASS_ROOT=`/usr/bin/pwgen -1sn 8`;
echo "UPDATE user SET password=PASSWORD('$PASS_ROOT') WHERE user='root';
flush  privileges;" | mysql --defaults-file=/etc/mysql/debian.cnf mysql

PASS_ENVOLE=`/usr/bin/pwgen -1sn 12`;
echo "DROP DATABASE IF EXISTS portal;CREATE DATABASE portal;"| mysql -u root --password=$PASS_ROOT
echo "use mysql;GRANT ALL PRIVILEGES ON portal.* TO 'envole'@'localhost'IDENTIFIED BY '$PASS_ENVOLE' WITH GRANT OPTION;flush  privileges;"| mysql -u root --password=$PASS_ROOT

PASS_CEL_CONF=`/usr/bin/pwgen -1sn 12`
echo "DROP DATABASE IF EXISTS cel_conf; CREATE DATABASE cel_conf; GRANT ALL PRIVILEGES ON cel_conf.* TO 'cel_conf'@'localhost'IDENTIFIED BY '$PASS_CEL_CONF' WITH GRANT OPTION;flush  privileges;" | mysql -u root --password=$PASS_ROOT

if [ ! -d /var/www/html/envole ] 
then
	echo  "Creation du rep envole" 
	mkdir /var/www/html/envole
fi

mysql portal -u root -p$PASS_ROOT < $SYS/scribe_envole.sql 

sed -e  "s@NOM_ETAB@$NOM_ETAB@" $SYS/scribe_cel_conf.sql   > $SYS/scribe_cel_conf.sql.1
sed -e  "s@RNE_ETAB@$RNE_ETAB@" $SYS/scribe_cel_conf.sql.1   > $SYS/scribe_cel_conf.sql.2
mysql cel_conf -u root -p$PASS_ROOT < $SYS/scribe_cel_conf.sql.2 
rm $SYS/scribe_cel_conf.sql.2
rm $SYS/scribe_cel_conf.sql.1
    
sed -e  "s@PASS_ENVOLE@$PASS_ENVOLE@" $SYS/serverdata.php.ori   > /var/www/html/envole/serverdata.php
sed -e  "s@PASS_CEL_CONF@$PASS_CEL_CONF@" $SYS/connect_cel_conf.php.ori   > /var/www/html/envole/connect_cel_conf.php

if [ -d /usr/share/squirrelmail ]
then
	cp $SYS/envole_squirrelmail.php.ori /usr/share/squirrelmail/src/envole.php
fi

chown -R www-data:www-data /var/www/html/*

if [ -d  /var/www/html/envole/IMG_CEL ]
then
	getent group cel_admin &>/dev/null || /usr/sbin/smbldap-groupadd cel_admin
	/usr/sbin/smbldap-groupmod -m admin cel_admin
	/usr/sbin/smbldap-groupmod -m Meta_eleve cel_admin
	/usr/sbin/smbldap-groupmod -m Meta_prof cel_admin
	/usr/sbin/smbldap-groupmod -m Meta_perdir cel_admin
	/usr/sbin/smbldap-groupmod -m Visiteur cel_admin
	ln -s /var/www/html/envole/IMG_CEL /home/M/Meta_eleve/.ftp/
	ln -s /var/www/html/envole/IMG_CEL /home/M/Meta_prof/.ftp/
	ln -s /var/www/html/envole/IMG_CEL /home/M/Meta_perdir/.ftp/
	ln -s /var/www/html/envole/IMG_CEL /home/V/Visiteur/.ftp/
	ln -s /var/www/html/envole/IMG_CEL /home/a/admin/.ftp/	
	chmod -R 775  /var/www/html/envole/IMG_CEL
	chown -R www-data:cel_admin /var/www/html/envole/IMG_CEL
fi

#service apache2 restart

echo "--------------------------------------------------------------"
echo "------Fin de l'instanciation initiale envole   $NUM_MAJ ------"
echo "--------------------------------------------------------------"

