#!/bin/bash


# A mettre a jour pour un nouveau script
NUM_MAJ=1
SYS="/etc/sysconfig/envole"

echo "--------------------------------------------------------------"
echo "-----------Debut de la mise a jour envole   $NUM_MAJ ---------"
echo "--------------------------------------------------------------"

. ParseDico

# compatibilite

NOM_DOMAINE=$domaine_messagerie_etab


#placer ici les modifications de fichiers
#seulement pour des fichiers de configuration
id Meta_parent &>/dev/null || /usr/share/eole/backend/creation-prof.py -u "Meta_parent" \
-m "meta_parent" -p "%MeT@_pAr6nt%" -f "meta_parent" -x 1 -M local -p 1 -z 0 -c autre -q 0;

sed -e "s@DNS_ETAB@"$NOM_DOMAINE"@" $SYS/cas_grr.php.ori   > /var/www/html/envole/cas/cas_grr.php
sed -e "s@DNS_ETAB@"$NOM_DOMAINE"@" $SYS/cas_wordpress.php.ori   > /var/www/html/envole/cas/cas_wordpress.php
sed -e "s@DNS_ETAB@"$NOM_DOMAINE"@" $SYS/cas_wordpressmu.php.ori    > /var/www/html/envole/cas/cas_wordpressmu.php
sed -e "s@DNS_ETAB@"$NOM_DOMAINE"@" $SYS/cas_calendar.php.ori    > /var/www/html/envole/cas/cas_calendar.php
sed -e "s@DNS_ETAB@"$NOM_DOMAINE"@" $SYS/cas_cdt.php.ori    > /var/www/html/envole/cas/cas_cdt.php



#placer ici les modifications de bases de donnees
PASS_ROOT=`/usr/bin/pwgen -1sn 8`;
echo "UPDATE user SET password=PASSWORD('$PASS_ROOT') WHERE user='root';
flush  privileges;" | mysql --defaults-file=/etc/mysql/debian.cnf mysql

PASS_PIWIK=`/usr/bin/pwgen -1sn 12`
echo "DROP DATABASE IF EXISTS piwik; CREATE DATABASE piwik; GRANT ALL PRIVILEGES ON piwik.* TO 'piwik'@'localhost'IDENTIFIED BY '$PASS_PIWIK' WITH GRANT OPTION;flush  privileges;" | mysql -u root --password=$PASS_ROOT

mysql piwik -u root -p$PASS_ROOT <	$SYS/scribe_piwik.sql 

sed -e  "s@PASS_PIWIK@"$PASS_PIWIK"@" $SYS/config.ini.piwik.php.ori   > /var/www/html/piwik/config/config.ini.php


chown -R www-data:www-data /var/www/html/piwik

# si la mise à jour comporte une modification de la base de données

if [ -e $SYS/maj_envole_portal_${NUM_MAJ}.sql ]
then

cd /root/
## Sauvegarde des bases de donnees en fichiers .sql
SOURCE="envole"
PASS_ENVOLE=$(echo `grep dbPass /var/www/html/envole/serverdata.php` | cut -d"=" -f2|cut -d'"' -f2)
mysqldump -uenvole -p$PASS_ENVOLE portal > ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
## Compression des exports en tar.bz2 
tar jcf ${SOURCE}_maj_env_${NUM_MAJ}_`date +%D | sed 's;/;-;g'`.sql.tar.bz2 ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
## Suppression des exports non compresses
rm ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql

mysql portal -u envole -p$PASS_ENVOLE < $SYS/maj_envole_portal_$NUM_MAJ.sql



fi

if [ -e $SYS/maj_envole_cel_conf_${NUM_MAJ}.sql ]
then

SOURCE="cel_conf"
PASS_CEL_CONF=$(echo `grep db_pass_cel_conf /var/www/html/envole/connect_cel_conf.php` | cut -d"=" -f2|cut -d'"' -f2)
mysqldump -ucel_conf -p$PASS_CEL_CONF $SOURCE > ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
## Compression des exports en tar.bz2
tar jcf ${SOURCE}_maj_env_${NUM_MAJ}_`date +%D | sed 's;/;-;g'`.sql.tar.bz2 ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
## Suppression des exports non compresses
rm ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql

sed -e  "s@DOMAINE_NAME@$NOM_DOMAINE@" $SYS/maj_envole_cel_conf_$NUM_MAJ.sql > $SYS/maj_envole_cel_conf_$NUM_MAJ.sql.1
	
#echo "mise a jour a partir de  $SYS/maj_envole_cel_conf_$NUM_MAJ.sql"
mysql cel_conf -u cel_conf -p$PASS_CEL_CONF < $SYS/maj_envole_cel_conf_$NUM_MAJ.sql.1
rm $SYS/maj_envole_cel_conf_$NUM_MAJ.sql.1

fi

#if [ -e $SYS/maj_envole_piwik_${NUM_MAJ}.sql ]
#then

#SOURCE="piwik"
#PASS_PIWIK=$(echo `grep db_pass_cel_conf /var/www/html/piwik/config/config.ini.php` | cut -d"=" -f2|cut -d'"' -f2)
#mysqldump -ucel_conf -p$PASS_CEL_CONF $SOURCE > ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
## Compression des exports en tar.bz2
#tar jcf ${SOURCE}_maj_env_${NUM_MAJ}_`date +%D | sed 's;/;-;g'`.sql.tar.bz2 ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
## Suppression des exports non compresses
#rm ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql

#mysql piwik -u piwik -p$PASS_PIWIK < $SYS/maj_envole_piwik_$NUM_MAJ.sql

#fi

## plus nécessaire Eole-2.2
#echo "Configuration du sso pour envole"
# mise en place des clés pem

#	openssl x509 -in /etc/ssl/scribe/server.crt -out /usr/share/sso/certs/server.der -outform DER
#	openssl x509 -in /usr/share/sso/certs/server.der -inform DER -out /usr/share/sso/certs/server.pem -outform PEM

#	cat /etc/ssl/scribe/server.key >> /usr/share/sso/certs/server.pem


# pour le local_apps et envole.ini
if [ ! -d /usr/share/sso/app_filters ]
then
mkdir /usr/share/sso/app_filters
fi

if [ ! -d /usr/share/sso/user_infos ]
then
mkdir /usr/share/sso/user_infos
cp $SYS/profil.py  /usr/share/sso/user_infos
fi

if [  -d /usr/share/sso/app_filters ]
then

	cp $SYS/*.ini /usr/share/sso/app_filters/
	sed -e "s@NOM_DOMAINE@"$NOM_DOMAINE"@" $SYS/cas.sso.ori  > /var/www/html/envole/cas/cas.sso

	sed -e "s@NOM_DOMAINE@"$NOM_DOMAINE"@" $SYS/local_apps.ini  > $SYS/local_apps.ini.1

	cat $SYS/local_apps.ini.1 >> /usr/share/sso/app_filters/local_apps.ini
	rm $SYS/local_apps.ini.1
# pour le profil
#cp $SYS/sso/user_infos/* /usr/share/sso/user_infos/	
fi

# insertion du champ de mise a jour cel dans la bdd cel_conf
PASS_CEL_CONF=$(echo `grep db_pass_cel_conf /var/www/html/envole/connect_cel_conf.php` | cut -d"=" -f2|cut -d'"' -f2)

echo "use cel_conf; INSERT INTO cel_param ( id , param , affichage , value, writable , visible , categorie )VALUES (NULL , 'version_deb', 'Numero de sous-version EnvOLE', '0', '0', '0', 'Etablissement'
); " | mysql -u cel_conf --password=$PASS_CEL_CONF > /dev/null


#service apache2 restart
service eole-sso restart


# A toujours laisser en fin de script de mise a jour, permet la mise a jour de la base de donnees cel_conf et assure que la mise a jour ne sera pas executee deux fois

PASS_CEL_CONF=$(echo `grep db_pass_cel_conf /var/www/html/envole/connect_cel_conf.php` | cut -d"=" -f2|cut -d'"' -f2)

 echo "UPDATE cel_param SET value='$NUM_MAJ' WHERE param='version_deb' ; " | mysql -u cel_conf -p$PASS_CEL_CONF cel_conf

echo "--------------------------------------------------------------"
echo "-----------Fin de la mise a jour envole   $NUM_MAJ ---------"
echo "--------------------------------------------------------------"

