<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title>prometeus - Interactive DHTML art-demos</title>
<meta name="Author" content="Gerard Ferrandez at http://www.dhteumeuleu.com">
<meta http-equiv="imagetoolbar" content="no">
<style type="text/css">
	html {
		overflow: hidden;
	}
	body {
		margin: 0px;
		padding: 0px;
		background: #111;
		position: absolute;
		width: 100%;
		height: 100%;
		cursor: crosshair;
	}
	#canvas {
		position:absolute;
		left: 0%;
		top: 0%;
		width: 100%;
		height: 100%;
		background: #000;
		overflow: hidden;
	}
	#canvas img {
		position: absolute;
		background: #666;
		overflow: hidden;
		cursor: pointer;
		left: 100%;
		border-color: #000;
		border-style: solid;
		border-width: 1px;
	}
	#canvas span {
		position: absolute;
		color: #9C9;
		font-family: 'courier new', typewriter, matrix, monospace;
		font-size: 0px;
		white-space: nowrap;
		left: -1000px;
		background:#010;
		filter: alpha(opacity=90);
		opacity:0.9;
	}
</style>
<script type="text/javascript">
// ============================================================================
// script realized by G?rard Ferrandez - June 2006
// http://www.dhteumeuleu.com
// ============================================================================

//////////////////////////////////////////////////////////////////////////////
var O    = [];
var cont = 0;
var N    = 0;
var S    = 0;
var img, spa;
var s = {xm:0, ym:0, nx:0, ny:0, nw:0, nh:0, cx:0, cy:0, zoom:1};
var c = {x:0, y:0, z:-40000, xt:0, yt:0, zt:0};

//////////////////////////////////////////////////////////////////////////////

function resize() {

	with(document.getElementById("canvas")){
		s.nx = offsetLeft;
		s.ny = offsetTop;
		s.nw = offsetWidth;
		s.nh = offsetHeight;
		s.zoom = s.nh / 700;
	}
}
onresize = resize;

document.onmousemove = function(e){
	if(window.event) e=window.event;
	s.xm = (e.x || e.clientX) - s.nx - s.nw * .5;
	s.ym = (e.y || e.clientY) - s.ny - s.nh * .5;
}

function CObj(n){
	this.n = n;
	this.x = s.zoom * Math.random() * s.nw * 2 - s.nw;
	this.y = s.zoom * Math.random() * s.nh * 2 - s.nh;
	this.z = Math.round(n * (10000 / N));
	this.w = img[n].width;
	this.h = img[n].height;
	this.oxt = spa[n];
	this.txt = spa[n].innerHTML;
	this.oxt.innerHTML = "";
	this.obj = img[n];
	this.obj.parent = this;
	this.obj.onclick = new Function("this.parent.click();");
	this.obj.ondrag = new Function("return false;");
	this.oxt.style.zIndex = this.obj.style.zIndex = Math.round(1000000 - this.z);
	this.F = false;
	this.CF = 100;
	this.sto = [];
	this.anim = function(){
		with(this){
			var f = 700 + z - c.z;
			if (f > 0) {
				var d = 1000 / f;
				var X = s.nw * .5 + ((x - c.x - s.cx) * d);
				var Y = s.nh * .5 + ((y - c.y - s.cy) * d);
				var W = d * w * s.zoom;
				var H = d * h * s.zoom;
				with(obj.style){
					left   = Math.round(X - W * .5)+"px";
					top    = Math.round(Y - H * .5)+"px";
					width  = Math.round(W)+"px";
					height = Math.round(H)+"px";
				}
				with(oxt.style){
					visibility = (CF-- > 0 && Math.random() > .9)?"hidden":"visible";
					left   = Math.round(X - W * .5)+"px";
					top    = Math.round(Y + H * .5)+"px";
					if((c.zt - c.z) < 20){
						if(!F){
							F = true;
							CF = Math.random() * 200;
							fontSize = 1 + Math.round(d * 20 * s.zoom)+"px";
							var T = "";
							var tn = txt.length;
							for(var i=0; i<tn; i++){
								T+=txt.charAt(i);
								sto[i] = setTimeout('O['+n+'].oxt.innerHTML = "'+(T+"_")+'";', Math.round(f/4)+32*i);
							}
						}
					} else F=false, oxt.innerHTML="";
				}
			} else {
				x = s.zoom * Math.random() * s.nw * 2 - s.nw;
				y = s.zoom * Math.random() * s.nh * 2 - s.nh;
				z += 10000;
				oxt.style.zIndex = obj.style.zIndex = Math.round(1000000 - z);
			}
		}
	}

	this.cto = function(){
		with(this){
			var tn = txt.length;
			for(var i=0; i<tn; i++){
				clearTimeout(sto[i]);
			}
		}
	}

	this.click = function(){
		for(var i in O)O[i].cto();
		with(this){
			var tn = txt.length;
			for(var i=0; i<tn; i++){
				clearTimeout(sto[i]);
			}
			if(S!=this){
				c.xt = x;
				c.yt = y;
				c.zt = z;
				S = this;
			} else {
				S = 0;
				c.zt += 1600;
			}
		}
	}
}

function run(){
	s.cx += (s.xm - s.cx) / 10;
	s.cy += (s.ym - s.cy) / 10;
    c.x  += (c.xt - c.x)  / 20;
    c.y  += (c.yt - c.y)  / 20;
    c.z  += (c.zt - c.z)  / 20;
	for(var i=0; i<N; i++) O[i].anim();
	setTimeout("run();", 16);
}

onload = function() {
	resize();
	s.cx = s.nw / 2;
	s.cy = s.nh / 2;
	cont = document.getElementById("canvas");
	img = document.getElementById("canvas").getElementsByTagName("img");
	spa = document.getElementById("canvas").getElementsByTagName("span");
	N = img.length;
	for(var i=0; i<N; i++) O[i] = new CObj(i);
	run();
	O[0].click();

}

</script>
</head>

<body>

<div id="canvas">
<img src="images/slide109.jpg"><span>Little girls may have taken<br>ballet lessons here.</span>
<img src="images/slide112.jpg"><span>Stealing fire from Gods</span>
<img src="images/slide94.jpg"><span>Mussgorsky's Gopak played in my head</span>
<img src="images/slide108.jpg"><span>The coffee tasted nice.<br>I nearly fainted, though.</span>
<img src="images/slide113.jpg"><span>The plant was closed for good.</span>
<img src="images/slide126.jpg"><span>They planned to direct all ressources<br>to public health.</span>
<img src="images/slide99.jpg"><span>I can almost hear them speak.</span>
<img src="images/slide121.jpg"><span>Will this be their Rosetta stone?</span>
<img src="images/slide111.jpg"><span>Absenteeism was dramatically lowered.</span>
<img src="images/slide120.jpg"><span>Carefully calibrated for radiation levels.</span>
<img src="images/slide123.jpg"><span>The underground is open forever.</span>
<img src="images/slide119.jpg"><span>The true cost of the disaster<br>will not be known for decades to come.</span>
<img src="images/slide132.jpg"><span>My journey had lasted seven hours.</span>
</div>

<!-- crossbrowser images_loading_bar - Gerard Ferrandez - www.dhteumeuleu.com - Feb 2005 -->
<span id="LB0" style="position:absolute;left:50%;top:50%;"><span style="position:absolute;font-family:arial;font-size:10px;color:#ccc;background:#000;left:-50px;top:-18px">Loading...</span><span style="position:absolute;left:-50px;top:-5px;font-size:1px;width:100px;height:10px;background:#333"><span id="LB1" style="position:absolute;font-size:1px;width:0px;height:10px;background:#ccc"></span></span></span>
<script>m00=document.getElementById("canvas").getElementsByTagName("img");m01=m00.length;function images_loading_bar(){m02=0;for(i=0;i<m01;i++)m02+=(m00[i].complete)?1:0;document.getElementById("LB1").style.width=Math.round(m02/m01*100);if(m02==m01)setTimeout("document.getElementById('LB0').style.display='none'",128); else setTimeout("images_loading_bar()", 64);};images_loading_bar();</script>
<!-- end of images_loading_bar code -->

</body>
</html>